package org.objectweb.kilim;

import org.objectweb.util.monolog.api.Level;
import org.objectweb.util.monolog.api.Logger;
import org.objectweb.util.monolog.api.LoggerFactory;

/**
 * @author delpiano
 *
 * A null logger, just in case the classpath of the application does not contain
 * any lgging functionality.
 */
public class NullLoggerFactory implements LoggerFactory {

	private NullLogger null_logger = new NullLogger();
	private Logger[] null_loggers = {null_logger};

	/**
	 * @see org.objectweb.util.monolog.api.LoggerFactory#getLogger(String)
	 */
	public Logger getLogger(String arg0) {
		return null_logger;
	}

	/**
	 * @see org.objectweb.util.monolog.api.LoggerFactory#getLogger(String, String)
	 */
	public Logger getLogger(String arg0, String arg1) {
		return null_logger;
	}

	/**
	 * @see org.objectweb.util.monolog.api.LoggerFactory#getResourceBundleName()
	 */
	public String getResourceBundleName() {
		return "Null Bundle Name";
	}

	/**
	 * @see org.objectweb.util.monolog.api.LoggerFactory#setResourceBundleName(String)
	 */
	public void setResourceBundleName(String arg0) {
	}

	/**
	 * @see org.objectweb.util.monolog.api.LoggerFactory#getLoggers()
	 */
	public Logger[] getLoggers() {
		return null_loggers;
	}

}

class NullLogger implements Logger {

	/**
	 * @see org.objectweb.util.monolog.api.Logger#getCurrentIntLevel()
	 */
	public int getCurrentIntLevel() {
		return 0;
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#getCurrentLevel()
	 */
	public Level getCurrentLevel() {
		return null;
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#isLoggable(int)
	 */
	public boolean isLoggable(int arg0) {
		return false;
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#isLoggable(Level)
	 */
	public boolean isLoggable(Level arg0) {
		return false;
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#isOn()
	 */
	public boolean isOn() {
		return false;
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#log(int, Object, Object, Object)
	 */
	public void log(int arg0, Object arg1, Object arg2, Object arg3) {
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#log(int, Object, Throwable, Object, Object)
	 */
	public void log(
		int arg0,
		Object arg1,
		Throwable arg2,
		Object arg3,
		Object arg4) {
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#log(int, Object, Throwable)
	 */
	public void log(int arg0, Object arg1, Throwable arg2) {
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#log(int, Object)
	 */
	public void log(int arg0, Object arg1) {
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#log(Level, Object, Object, Object)
	 */
	public void log(Level arg0, Object arg1, Object arg2, Object arg3) {
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#log(Level, Object, Throwable, Object, Object)
	 */
	public void log(
		Level arg0,
		Object arg1,
		Throwable arg2,
		Object arg3,
		Object arg4) {
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#log(Level, Object, Throwable)
	 */
	public void log(Level arg0, Object arg1, Throwable arg2) {
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#log(Level, Object)
	 */
	public void log(Level arg0, Object arg1) {
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#setIntLevel(int)
	 */
	public void setIntLevel(int arg0) {
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#setLevel(Level)
	 */
	public void setLevel(Level arg0) {
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#turnOff()
	 */
	public void turnOff() {
	}

	/**
	 * @see org.objectweb.util.monolog.api.Logger#turnOn()
	 */
	public void turnOn() {
	}

	/**
	 * @see org.objectweb.util.monolog.api.Handler#getAttribute(String)
	 */
	public Object getAttribute(String arg0) {
		return null;
	}

	/**
	 * @see org.objectweb.util.monolog.api.Handler#getAttributeNames()
	 */
	public String[] getAttributeNames() {
		return null;
	}

	/**
	 * @see org.objectweb.util.monolog.api.Handler#getName()
	 */
	public String getName() {
		return null;
	}

	/**
	 * @see org.objectweb.util.monolog.api.Handler#getType()
	 */
	public byte getType() {
		return 0;
	}

	/**
	 * @see org.objectweb.util.monolog.api.Handler#setAttribute(String, Object)
	 */
	public Object setAttribute(String arg0, Object arg1) {
		return null;
	}

	/**
	 * @see org.objectweb.util.monolog.api.Handler#setName(String)
	 */
	public void setName(String arg0) {
	}

}
