/**
 * Copyright (C) 2002 Kelua SA
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.objectweb.kilim.description;

import java.util.Iterator;

import org.objectweb.kilim.KilimException;

/**
 * @author horn
 */
public class EventSource implements BasicElement {
	/** EVENT_SOURCE is a singleton indicating that a parameter or a support is the trigger source */
	public static final EventSource EVENT_SOURCE = new EventSource();

	private EventSource() { }
	
	/**
	 * @see org.objectweb.kilim.description.lang.Source#isEventSource()
	 */
	public boolean isEventSource() {
		return true;
	}
	
	/**
	 * @see org.objectweb.kilim.description.TemplateElement#providesValue()
	 */
	public boolean providesValue() {
		return true;
	}
	
	/**
	 * @see org.objectweb.kilim.description.TemplateElement#performsAction()
	 */
	public boolean performsAction() {
		return false;
	}
				
	/**
	 * @see org.objectweb.kilim.description.TemplateElement#getContainingTemplate()
	 */
	public TemplateDescription getContainingTemplate() {
		return null;
	}
	
	/**
	 * @see org.objectweb.kilim.description.TemplateElement#getTemplateDefHierarchy()
	 */
	public Iterator getTemplateDefHierarchy() {
		return KILIM.EMPTY_ITERATOR;
	}
		
	/**
	 * @see org.objectweb.kilim.description.TemplateElement#setContainingTemplate(TemplateDescription)
	 */
	public void setContainingTemplate(TemplateDescription aTemplate) throws KilimException { }
				
	/**
	 * @see org.objectweb.kilim.description.BasicElement#getKind()
	 */
	public int getKind() {
		return KILIM.EVENT_SOURCE;
	}
	
	/**
	 * @see java.lang.Object#clone()
	 */
	public Object clone() {
		return this;
	}
}

	/**
	 * Method setLocalName.
	 * @param aName
	 * @throws KilimException
	 *
	 * 
	 public String getLocalName() {
		return null;
	}

	public void setLocalName(String aName) throws KilimException {
		throw new KilimException("attempt to set a local name to an event source in template " + getContainingTemplate().getName());
	}
	*/
