/**
 * Copyright (C) 2002 Kelua SA
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.objectweb.kilim.description;

/**
 * @author horn
 */
public class Parameter {
	private String name;
	private String typeName;
	private BasicElement target;

	/**
	 * Method ParameterImpl.
	 * @param aName : the name of the parameter
	 * @param aTypeName : the type of the parameter
	 * @param aTarget : the value of the parameter
	 */
	public Parameter(String aName, String aTypeName, BasicElement aTarget) {
		name = aName;
		typeName = aTypeName;
		target = aTarget;
	}
	
	/**
	 * @see org.objectweb.kilim.description.Parameter#getName()
	 */
	public String getName() {
		return name;
	}
		
	/**
	 * @see org.objectweb.kilim.description.Parameter#getTypeName()
	 */
	public String getTypeName() {
		return typeName;
	}
	
	/**
	 * @see org.objectweb.kilim.description.Parameter#getTypeName()
	 */
	public void setTypeName(String aTypeName) {
		typeName = aTypeName;
	}
	
	/**
	 * @see org.objectweb.kilim.description.Parameter#getTarget()
	 */
	public BasicElement getTarget() {
		return target;
	}
	
	/**
	 * @see org.objectweb.kilim.description.Parameter#setTarget(BasicElement)
	 */
	public void setTarget(BasicElement aTarget) {
		target = aTarget;
	}
	
	/**
	 * Method isEventSource.
	 * @return boolean
	 */
	public boolean isEventSource() {
		return false;
	}
}