/**
 * Copyright (C) 2002 Kelua SA
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.objectweb.kilim.repository;

import java.io.InputStream;

/**
 * @author dutoo
 * Resource loading wrapper.
 */
public interface ResourceLoader {
   
   /**
    * Method getResource. Loads a data resource.
    * @param resourcePath the path identifying the resource to be loaded
    * @return InputStream the resource data stream
    * @throws ResourceNotFoundException if unable to find the resource
    */
   InputStream getResource(String resourcePath) throws ResourceNotFoundException;
}
