/**
 * Copyright (C) 2002 Kelua SA
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is  distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.objectweb.kilim.repository;

/**
 * @author dutoo
 * Thrown when a required template was not found in the repository.
 * @see org.objectweb.kilim.repository.Repository
 */
public class ResourceNotFoundException extends Exception {
   
   /**
    * @see java.lang.Throwable#Throwable(String)
    */
   public ResourceNotFoundException(String aResourceName) {
      resourceName = aResourceName;
   }
   
   /**
    * @see java.lang.Throwable#getMessage()
    */
   public String getMessage() {
     return "Can't find resource " + resourceName;
   }
   
   /**
    * Method getResourceName.
    * @return String he path of the resource
    */
   public String getResourceName() {
      return resourceName;
   }
   
   /**
    * @see java.lang.Object#toString()
    */
   public String toString() {
      return "TemplateNotFoundException[" + resourceName + "]";
   }
   
   private String resourceName;
}
