package org.objectweb.kilim.tools;

import java.util.Iterator;

import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

import org.objectweb.kilim.KilimException;
import org.objectweb.kilim.description.Instance;
import org.objectweb.kilim.description.Slot;
import org.objectweb.kilim.description.TemplateDescription;

/**
 * @author delpiano
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class KilimTemplateTreeModel implements TreeModel {

	private TemplateDescription template;

	/**
	 * Method KilimTemplateTreeModel.
	 * @param tmplt :
	 */
	public KilimTemplateTreeModel(TemplateDescription tmplt) {
		super();
		template = tmplt;
	}

	/**
	 * @see javax.swing.tree.TreeModel#getRoot()
	 */
	public Object getRoot() {
		return template;
	}

	/**
	 * @see javax.swing.tree.TreeModel#getChild(Object, int)
	 */
	public Object getChild(Object parent, int index) {
		TemplateDescription tmplt_t_b_dsplyd;
		
		if (parent instanceof TemplateDescription) {
			tmplt_t_b_dsplyd = (TemplateDescription) parent;
		} else if (parent instanceof Instance) {
			tmplt_t_b_dsplyd = ((Instance) parent).getTemplate();
		} else if (parent instanceof Slot) {
			return getChildOfSlot((Slot) parent, index);
		} else {
			return null;	
		}
		try {
		
			Iterator prts = tmplt_t_b_dsplyd.getPorts(false);
			Iterator prvdrs = tmplt_t_b_dsplyd.getProviders(false);
			Iterator trnsfrmrs = tmplt_t_b_dsplyd.getTransformers(false);
			Iterator bndgs = tmplt_t_b_dsplyd.getBindings(false);
			Iterator trggrs = tmplt_t_b_dsplyd.getTriggers(false);
			Iterator prprts = tmplt_t_b_dsplyd.getProperties(false);
			Iterator instncs = tmplt_t_b_dsplyd.getInstances(false);
			Iterator slts = tmplt_t_b_dsplyd.getSlots(false);
			Iterator plgs = tmplt_t_b_dsplyd.getPlugs(false);
			
			int cntr = 0;
			for (; prts.hasNext(); cntr++) {
				Object prt = prts.next();
				if (cntr == index) {
					return prt;
				}
			}
			for (; prvdrs.hasNext(); cntr++) {
				Object prvdr = prvdrs.next();
				if (cntr == index) {
					return prvdr;
				}
			}		
			for (; trnsfrmrs.hasNext(); cntr++) {
				Object trnsfrmr = trnsfrmrs.next();
				if (cntr == index) {
					return trnsfrmr;
				}
			}
			for (; bndgs.hasNext(); cntr++) {
				Object bndg = bndgs.next();
				if (cntr == index) {
					return bndg;
				}
			}
			for (; trggrs.hasNext(); cntr++) {
				Object trggr = trggrs.next();
				if (cntr == index) {
					return trggr;
				}
			}
			for (; prprts.hasNext(); cntr++) {
				Object prprt = prprts.next();
				if (cntr == index) {
						return prprt;
				}
			}
			for (; instncs.hasNext(); cntr++) {
				Object instnc = instncs.next();
				if (cntr == index) {
					return instnc;
				}
			}	
			for (; slts.hasNext(); cntr++) {
				Object slt = slts.next();
				if (cntr == index) {
					return slt;
				}
			}	
			for (; plgs.hasNext(); cntr++) {
				Object plg = plgs.next();
				if (cntr == index) {
					return plg;
				}
			}						
		} catch (KilimException exp) {
			exp.printStackTrace();
			return null;
		}
		
		return null;
	}

	private Object getChildOfSlot(Slot slt, int index) {
			Iterator prts = slt.getPorts();
			int cntr = 0;
			for (; prts.hasNext(); cntr++) {
				Object prt = prts.next();
				if (cntr == index) {
					return prt;
				}
			}
			return null;
	}

	/**
	 * @see javax.swing.tree.TreeModel#getChildCount(Object)
	 */
	public int getChildCount(Object parent) {
		
		TemplateDescription tmplt_t_b_dsplyd;
		
		if (parent instanceof TemplateDescription) {
			tmplt_t_b_dsplyd = (TemplateDescription) parent;
		} else if (parent instanceof Instance) {
			tmplt_t_b_dsplyd = ((Instance) parent).getTemplate();
		} else if (parent instanceof Slot) {
			return getChildCountOfSlot((Slot) parent);
		} else {
			return 0;	
		}
		int cntr = 0;
		
		try {
		
			Iterator prts = tmplt_t_b_dsplyd.getPorts(false);
			Iterator prvdrs = tmplt_t_b_dsplyd.getProviders(false);
			Iterator trnsfrmrs = tmplt_t_b_dsplyd.getTransformers(false);
			Iterator bndgs = tmplt_t_b_dsplyd.getBindings(false);
			Iterator trggrs = tmplt_t_b_dsplyd.getTriggers(false);
			Iterator prprts = tmplt_t_b_dsplyd.getProperties(false);
			Iterator instncs = tmplt_t_b_dsplyd.getInstances(false);
			Iterator slts = tmplt_t_b_dsplyd.getSlots(false);
			Iterator plgs = tmplt_t_b_dsplyd.getPlugs(false);
			
			for (; prts.hasNext(); cntr++) {
				Object prt = prts.next();
			}
			for (; prvdrs.hasNext(); cntr++) {
				Object prvdr = prvdrs.next();
			}		
			for (; trnsfrmrs.hasNext(); cntr++) {
				Object trnsfrmr = trnsfrmrs.next();
			}
			for (; bndgs.hasNext(); cntr++) {
				Object bndg = bndgs.next();
			}
			for (; trggrs.hasNext(); cntr++) {
				Object trggr = trggrs.next();
			}
			for (; prprts.hasNext(); cntr++) {
				Object prprt = prprts.next();
			}
			for (; instncs.hasNext(); cntr++) {
				Object instnc = instncs.next();
			}		
			for (; slts.hasNext(); cntr++) {
				Object slt = slts.next();
			}
			for (; plgs.hasNext(); cntr++) {
				Object plg = plgs.next();
			}				
		} catch (KilimException exp) {
			exp.printStackTrace();
			return cntr;
		}
		
		return cntr;
	}

	private int getChildCountOfSlot(Slot slt) {
			Iterator prts = slt.getPorts();
			int cntr = 0;
			for (; prts.hasNext(); cntr++) {
				Object prt = prts.next();
			}
			return cntr;
	}

	/**
	 * @see javax.swing.tree.TreeModel#isLeaf(Object)
	 */
	public boolean isLeaf(Object node) {
		return (!((node instanceof TemplateDescription) || (node instanceof Instance) || (node instanceof Slot)));
	}

	/**
	 * @see javax.swing.tree.TreeModel#valueForPathChanged(TreePath, Object)
	 */
	public void valueForPathChanged(TreePath path, Object newValue) {
	}

	/**
	 * @see javax.swing.tree.TreeModel#getIndexOfChild(Object, Object)
	 */
	public int getIndexOfChild(Object parent, Object child) {
		TemplateDescription tmplt_t_b_dsplyd;
		
		if (parent instanceof TemplateDescription) {
			tmplt_t_b_dsplyd = (TemplateDescription) parent;
		} else if (parent instanceof Instance) {
			tmplt_t_b_dsplyd = ((Instance) parent).getTemplate();
		} else if (parent instanceof Slot) {
			return getIndexOfChildInSlot((Slot) parent, child);
		} else {
			return -1;	
		}
		try {
		
			Iterator prts = tmplt_t_b_dsplyd.getPorts(false);
			Iterator prvdrs = tmplt_t_b_dsplyd.getProviders(false);
			Iterator trnsfrmrs = tmplt_t_b_dsplyd.getTransformers(false);
			Iterator bndgs = tmplt_t_b_dsplyd.getBindings(false);
			Iterator trggrs = tmplt_t_b_dsplyd.getTriggers(false);
			Iterator prprts = tmplt_t_b_dsplyd.getProperties(false);
			Iterator instncs = tmplt_t_b_dsplyd.getInstances(false);
			Iterator slts = tmplt_t_b_dsplyd.getSlots(false);
			Iterator plgs = tmplt_t_b_dsplyd.getPlugs(false);
			
			int cntr = 0;
			for (; prts.hasNext(); cntr++) {
				Object prt = prts.next();
				if (prt == child) {
					return cntr;
				}
			}
			for (; prvdrs.hasNext(); cntr++) {
				Object prvdr = prvdrs.next();
				if (prvdr == child) {
					return cntr;
				}
			}		
			for (; trnsfrmrs.hasNext(); cntr++) {
				Object trnsfrmr = trnsfrmrs.next();
				if (trnsfrmr == child) {
					return cntr;
				}
			}
			for (; bndgs.hasNext(); cntr++) {
				Object bndg = bndgs.next();
				if (bndg == child) {
					return cntr;
				}
			}
			for (; trggrs.hasNext(); cntr++) {
				Object trggr = trggrs.next();
				if (trggr == child) {
					return cntr;
				}
			}
			for (; prprts.hasNext(); cntr++) {
				Object prprt = prprts.next();
				if (prprt == child) {
					return cntr;
				}
			}
			for (; instncs.hasNext(); cntr++) {
				Object instnc = instncs.next();
				if (instnc == child) {
					return cntr;
				}
			}	
			for (; slts.hasNext(); cntr++) {
				Object slt = slts.next();
				if (slt == child) {
					return cntr;
				}
			}
			for (; plgs.hasNext(); cntr++) {
				Object plg = plgs.next();
				if (plg == child) {
					return cntr;
				}
			}			
		} catch (KilimException exp) {
			exp.printStackTrace();
			return -1;
		}
		
		return -1;
	}
	
	private int getIndexOfChildInSlot(Slot slot, Object child) {
			Iterator prts = slot.getPorts();
			int cntr = 0;
			for (; prts.hasNext(); cntr++) {
				Object prt = prts.next();
				if (prt == child) {
					return cntr;
				}
			}
			return -1;
	}

	/**
	 * @see javax.swing.tree.TreeModel#addTreeModelListener(TreeModelListener)
	 */
	public void addTreeModelListener(TreeModelListener l) {
	}

	/**
	 * @see javax.swing.tree.TreeModel#removeTreeModelListener(TreeModelListener)
	 */
	public void removeTreeModelListener(TreeModelListener l) {
	}

}
